<template>
  <div id="class_index_wrapper" class="bt-container">
    <h1 class="page-title">{{ $t('ENROLL_TABLE.REG_CRS') }} </h1>
		<el-card class="box-card">
			<el-form>
				<el-form-item>
					<el-col :span="7.5">
						<span>{{ $t('ENROLL_TABLE.CRS_BEL_CODE') }}</span>
            <!-- 20210428 기관코드 설명 추가 -->
            <el-popover
              style="position: relative; left: 3px; top: 3px;"
              placement="top-start"
              width="300"
              trigger="hover">              
              <span style="margin-left: 10px;">{{"기관에서 개설된 주제 목록을 확인하고 신청할 수 있습니다. 기관 코드는 담당자에게 문의하세요."}}</span>
              <i class="el-icon-question fa-lg" slot="reference"></i>
            </el-popover>
						<el-input :placeholder="$t('ENROLL_TABLE.ENTER_BELONGING')" v-model="publicCode"  style="margin-left: 10px; width: 230px;"></el-input>
            <el-button style="margin-left: 10px;" type="primary" @click="submitCode()">{{ $t('ENROLL_TABLE.CONFIRM') }}</el-button>
					</el-col>					
          <el-button style="float: right; margin-right: 40px;" icon="el-icon-refresh" :key="refreshDisable" type="success" @click="updateUserBelongings()"
            :disabled="refreshDisable">{{ $t('ENROLL_TABLE.REFRESH') }}</el-button>
          <span :style="`float: right; margin-right: 20px; visibility: ${refreshCountDown > 0 ? 'visible' : 'hidden'};`">{{ $t('ENROLL_TABLE.TRY_AFT', { time: refreshCountDown }) }}</span>
				</el-form-item>
      </el-form>
			<el-tabs type="border-card" v-model="activeTab">
        <div v-if="user_belonging_list.length === 0">
				  <div style="text-align: center;">{{ $t('ENROLL_TABLE.NO_BELONGING_STUDENT') }}</div>
          <div style="text-align: center;">{{ $t('ENROLL_TABLE.NO_BELONGING_STUDENT2') }}</div>
        </div>
        <el-tab-pane v-else v-for="(data, index) in user_belonging_list" :key="index" :label="data.affiliation_name" :name="String(index)">
					<class-enrollment-table
						:list="user_belonging_list[Number(activeTab)].classList"
						:onClick="onClick"
						:key="refreshCount">
					</class-enrollment-table>
				</el-tab-pane>
			</el-tabs>
      <el-form style="margin-top: 30px;">
				<el-form-item>					
					<el-col :span="10">
						<span style="margin-left: 10px;">{{ $t('ENROLL_TABLE.CRS_PASSWORD') }}</span>
            <!-- 2021-04-28 주제코드 설명 추가 -->
            <el-popover
              style="position: relative; left: 3px; top: 3px;"
              placement="top-start"
              width="300"
              trigger="hover">              
              <span style="margin-left: 10px;">{{"기관 내 개설된 주제에 참가합니다. 주제 코드는 강의자에게 문의하세요."}}</span>
              <i class="el-icon-question fa-lg" slot="reference"></i>
            </el-popover>
						<el-input :placeholder="$t('ENROLL_TABLE.ENTER_PASSWORD')" v-model="privateCode" style="margin-left: 10px; width: 230px;"></el-input>
						<el-button style="margin-left: 10px;" type="primary" @click="submitCode()">{{ $t('ENROLL_TABLE.CONFIRM') }}</el-button>
					</el-col>          
				</el-form-item>
      </el-form>
		</el-card>
    <h1 class="page-title">{{ $t('PREVIEW_TABLE.TITLE') }}</h1>
	  <el-card class="box-card">
      <student-preview-table
        :list="list"
        :onClick="onClick"
      />
    </el-card>
    <!-- <h1 class="page-title">{{ $t('FOLLOW_TABLE.TITLE') }}</h1>
	  <el-card class="box-card">
      <student-preview-table
        :list="list"
        :onClick="onClick"
      />
    </el-card> -->
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import ClassEnrollmentTable from '../partials/ClassEnrollmentTable';
import ClassEnrollmentSelection from '../partials/ClassEnrollmentSelection';
import userService from '../../services/userService';
import enrollmentService from '../../services/enrollmentService';
import classService from '../../services/classService';
import utils from '../../utils';
import StudentPreviewTable from '../partials/StudentPreviewTable';

export default {
  name: 'ClassIndex',
  components: {
    ClassEnrollmentTable,
    ClassEnrollmentSelection,
    StudentPreviewTable,
  },
  computed: {
    ...mapState('NNclass', ['previewClassList']),
  },
  async beforeMount() {
    const vm = this;

    // 새로고침(Refresh, F5) 해도 목록을 가져올 수 있게 하는 부분.
    // TODO: 속도가 눈에 보이게 느려지므로 다른 방법이 있다면 수정 요구.
    await vm.getMyClassLists();
    // 검색 기능 : 서버에서 DB 쿼리로 처리하는 게 효율이 나을 것 같으면 나중에 수정.
    if (vm.previewClassList !== null) {
      if (vm.$route.query.type !== undefined) {
        vm.searchType = vm.$route.query.type;
      }
      if (vm.$route.query.text !== undefined) {
        vm.searchText = vm.$route.query.text;
      }
      for (let i = 0; i < vm.previewClassList.length; i += 1) {
        if (vm.searchType === 'name') {
          if (vm.previewClassList[i].name.includes(vm.searchText)) {
            vm.list.push(vm.previewClassList[i]);
          }
        }
        if (vm.searchType === 'teacher') {
          if (vm.previewClassList[i].master.name.includes(vm.searchText)) {
            vm.list.push(vm.previewClassList[i]);
          }
        }
      }
    }
    vm.loading = true;
  },
  data() {
    return {
      userId: utils.getUserIdFromJwt(),
      refreshDisable: false,
      refreshCountDown: 0,
      searchType: 'name',
      searchText: '',
      list: [],
      refreshCount: 0,
      publicCode: '',
			privateCode: '',
			user_belonging_list: [],
      activeTab: '0',
      loading: false,
    };
	},
	async mounted() {
		const vm = this;
    vm.updateUserBelongings();
	},
  methods: {
    ...mapActions('NNclass', [
      'getClassLists',
      'getMyClassLists',
      'deleteClassUser',
    ]),
    async updatePreviewList() {
      const vm = this;

      // 새로고침(Refresh, F5) 해도 목록을 가져올 수 있게 하는 부분.
      // TODO: 속도가 눈에 보이게 느려지므로 다른 방법이 있다면 수정 요구.
      await vm.getMyClassLists();
      vm.list = [];
      // 검색 기능 : 서버에서 DB 쿼리로 처리하는 게 효율이 나을 것 같으면 나중에 수정.
      if (vm.previewClassList !== null) {
        if (vm.$route.query.type !== undefined) {
          vm.searchType = vm.$route.query.type;
        }
        if (vm.$route.query.text !== undefined) {
          vm.searchText = vm.$route.query.text;
        }
        for (let i = 0; i < vm.previewClassList.length; i += 1) {
          if (vm.searchType === 'name') {
            if (vm.previewClassList[i].name.includes(vm.searchText)) {
              vm.list.push(vm.previewClassList[i]);
            }
          }
          if (vm.searchType === 'teacher') {
            if (vm.previewClassList[i].master.name.includes(vm.searchText)) {
              vm.list.push(vm.previewClassList[i]);
            }
          }
        }
      }
      vm.loading = true;
    },
		async updateUserBelongings() {
      const vm = this;
      const belongingList = await userService.getUserBelongings();
      // 새로고침 countdown 부분
      vm.refreshDisable = true;
      vm.refreshCountDown = 3;
      setTimeout(() => {
        vm.refreshDisable = false;
      }, 3000);
      setTimeout(() => {
        vm.refreshCountDown -= 1;
      }, 1000);
      setTimeout(() => {
        vm.refreshCountDown -= 1;
      }, 2000);
      setTimeout(() => {
        vm.refreshCountDown -= 1;
      }, 3000);
      if (belongingList.data.response === undefined) {
        return;
      }
      // 학생 소속(학부 이런거) 받아와서 user_belonging_list에 저장
      vm.user_belonging_list = belongingList.data.response;
      // belonging log가 여러개라서 가장 최신거를 enrollments에 넣음
      vm.user_belonging_list.forEach((list) => {
        // enrollments 수정
        list.classList.forEach(async (classData) => {
          let enrollmentsData = null;
          // 가장 최신거 넣음
          classData.enrollments.forEach((log) => {
            if (enrollmentsData === null) {
              enrollmentsData = log;
            } else if (new Date(log.created_at) > new Date(enrollmentsData.created_at)) {
              enrollmentsData = log;
            } else if (parseInt(log.type) === 4) {
              enrollmentsData = log;
            }
          });
          classData.enrollments = enrollmentsData;
          classData.rate = await classService.getClassRating({classId: classData.class_id,});
          classData.rate = classData.rate.data.rate;
          if(classData.rate === null) {
            classData.rate = 0;
          }
        });
        // 비공개 강의 숨기기
        list.classList = list.classList.filter(classData => classData.view_type === 1);
      });
		},
    async submitCode() {
      const vm = this;
      let type = [];      
      
      if (vm.publicCode !== '') {
        type.push('public');
      }

      if (vm.privateCode !== '') {
        type.push('private');
      }

      if (type.length === 0) {
        vm.$notify({
          title: vm.$t('ENROLL_TABLE.CONFIRM_INPUT'),
          message: vm.$t('ENROLL_TABLE.ENTER_BELONGING_OR_PASSWORD'),
          type: 'warning',
          duration: 3000,
        });
        return;
      }
      // 동시에 입력했을 때
      if (type.length > 1) {
        const class_belonging = await classService.getClassBelongingByCode({ code: vm.publicCode });
        const class_enroll_password = await classService.getClassEnrollPasswordByPassword({ pwd: vm.privateCode });
        let class_password = null;
        if (class_enroll_password.data.class_enroll_password !== null) {
          class_password = await classService.getClassPasswordById({ id: class_enroll_password.data.class_enroll_password.class_id });
        }
        // 해당 소속코드와 비밀번호가 호환되면(비밀번호에 해당하는 비공개 강의의 소속과 소속코드의 소속이 같을 경우에)
        if (class_password !== null && class_belonging.data.result !== null && class_belonging.data.result.class_belonging_id === class_password.data.data.class_belonging_id) {
          type = ['private'];
        } else {
          type = [];
          vm.$notify({
						title: vm.$t('ENROLL_TABLE.BELONGING_OR_PASSWORD'),
						message: vm.$t('ENROLL_TABLE.BELONGING_NOT_EQUAL_PASSWORD'),
						type: 'error',
						duration: 3000,
          });
        }
      } 
      if (type.includes('public')) {
        if (vm.publicCode === '') {
          vm.$notify({
            title: vm.$t('ENROLL_TABLE.ERROR_PASSWORD'),
            message: vm.$t('ENROLL_TABLE.ENTER_COURSE_PASSWORD'),
            type: 'error',
            duration: 5000,
          });
          return;
        }

				// 소속 등록하기
				const belongingAdd = await userService.postUserBelonging({
					code: vm.publicCode,
				});

				if (belongingAdd.data.data === 'already exist') {
					vm.$notify({
						title: vm.$t('ENROLL_TABLE.ADD_BELONGING_CODE'),
						message: vm.$t('ENROLL_TABLE.EXIST_BELONGING_CODE'),
						type: 'error',
						duration: 3000,
					});
				} else if (belongingAdd.data.data === 'unvalid') {
					vm.$notify({
						title: vm.$t('ENROLL_TABLE.ADD_BELONGING_CODE'),
						message: vm.$t('ENROLL_TABLE.UNVALID_BELONGING_CODE'),
						type: 'error',
						duration: 3000,
					});
				}
      } else if (type.includes('private')) {
        // 강의 등록하기
        const result = await classService.enrollClassByPassword({
          password: vm.privateCode,
        });
        switch (result.data.result) {
          case 0: {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.PASSWORD_ENTER'),
              message: vm.$t('ENROLL_TABLE.UNVALID_PASSWORD'),
              type: 'error',
              duration: 3000,
            });
            break;
          }
          case 1: {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.PASSWORD_ENTER'),
              message: vm.$t('ENROLL_TABLE.EXIST_PASSWORD'),
              type: 'error',
              duration: 3000,
            });
            break;
          }
          case 2: {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.PASSWORD_ENTER'),
              message: vm.$t('ENROLL_TABLE.SUCCESS_ENROLLMENT'),
              type: 'success',
              duration: 3000,
            });
            break;
          }
          default: {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.PASSWORD_ENTER'),
              message: vm.$t('ENROLL_TABLE.ASK_ADMIN'),
              type: 'error',
              duration: 3000,
            });
          }
        }
      }
      vm.publicCode = '';
      vm.privateCode = '';
      if (type.length === 1) {
        vm.updateUserBelongings();
      }
    },
    formatDate: utils.formatDate,
    async onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'LISTEN': {
          vm.$router.push(`/a/student/NNclass/${arg.class_id}`);
          break;
        }
        case 'CANCEL_PREVIEW': {
          vm.$confirm(vm.$t('CONFIRM.WANT_CNL_CRS'), `${arg.name || ''} ` + vm.$t('CONFIRM.CANCEL_COURSE'), {
            confirmButtonText: vm.$t('CONFIRM.YES_CANCEL'),
            cancelButtonText: vm.$t('CONFIRM.NO_CANCEL'),
            type: 'warning',
          }).then(async () => {
            const res = await enrollmentService.deleteCancelPreview({ 
              class_id: arg.class_id,
            });
            await vm.updateUserBelongings();
            await vm.updatePreviewList();
            vm.$notify({
              title: vm.$t('NOTIFY.CANCEL_GO'),
              message: vm.$t('NOTIFY.CANCEL_DONE'),
              type: 'success',
              duration: 3000,
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('NOTIFY.INTERRUPTED'),
              message: vm.$t('NOTIFY.CUR_SGN_UP_INTRP'),
              type: 'info',
              duration: 3000,
            });
          });
          break;
        }
        case 'ENROLL': {
          const enrollCheck = await enrollmentService.checkEnrollmentTime({
            class_id: arg.class_id,
          });
          const belongingList = await userService.getUserBelongings();
          belongingList.data.response.forEach(async (x) => {
            x.classList.forEach(async (x) => {
              if (x.class_id === arg.class_id) {
                enrollCheck.data.type = x.type;
              }
            });
          });
          if (enrollCheck.data.status !== 'during' && parseInt(enrollCheck.data.type, 10) !== 4) {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.REG_CRS'),
              message: vm.$t('ENROLL_TABLE.UNVALID_APPLY_DURATION'),
              type: 'error',
              duration: 3000,
            });
            return;
          }
          let response;
          await vm.$confirm(vm.$t('ENROLL_TABLE.ASK_ENROLLMENT')).then(async () => {
            response = await enrollmentService.postEnrollment({
              class_id: arg.class_id,
            });
            await vm.updateUserBelongings();
            await vm.updatePreviewList();
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.REG_CRS'),
              message: vm.$t('ENROLL_TABLE.SUCCESS_MSG'),
              type: 'success',
              duration: 3000,
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.REG_CRS'),
              message: vm.$t('ENROLL_TABLE.CANCEL_MSG'),
              type: 'warning',
              duration: 3000,
            });
          });
          if (parseInt(response.data.result.type, 10) === 4) {
            const isProd = document.URL.includes('preswot');
            let url;
            if (isProd) {
              url = 'https://preswot.com';
            } else {
              url = 'http://localhost:3000';
            }
            vm.loading = false;
            vm.$router.push({ name: "NNStudentClassShow", params: { classId: arg.class_id } });
          }
          break;
        }
        case 'CANCEL': {
          vm.$confirm(vm.$t('CONFIRM.WANT_CNL_CRS'), `${arg.name || ''} ` + vm.$t('CONFIRM.CANCEL_COURSE'), {
            confirmButtonText: vm.$t('CONFIRM.YES_CANCEL'),
            cancelButtonText: vm.$t('CONFIRM.NO_CANCEL'),
            type: 'warning',
          }).then(async () => {
            const response = await enrollmentService.deleteEnrollment({ 
              class_id: arg.class_id,
            });
            vm.updateUserBelongings();
            vm.$notify({
              title: vm.$t('NOTIFY.CANCEL_GO'),
              message: vm.$t('NOTIFY.CANCEL_DONE'),
              type: 'success',
              duration: 3000,
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('NOTIFY.INTERRUPTED'),
              message: vm.$t('NOTIFY.CUR_SGN_UP_INTRP'),
              type: 'info',
              duration: 3000,
            });
          });
          break;
        }
        case 'REJECTED': {
          vm.$confirm(vm.$t('ENROLL_TABLE.RETRY_REJECTED')).then(async () => {
            const response = await enrollmentService.postEnrollment({ 
              class_id: arg.class_id,
            });
            vm.updateUserBelongings();
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.REG_CRS'),
              message: vm.$t('ENROLL_TABLE.SUCCESS_MSG'),
              type: 'success',
              duration: 3000,
            });
          }).catch((err) => {
            vm.$notify({
              title: vm.$t('ENROLL_TABLE.REG_CRS'),
              message: vm.$t('ENROLL_TABLE.CANCEL_MSG'),
              type: 'warning',
              duration: 3000,
            });
          });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
};
</script>


<style lang="scss" scoped>

#class_index_wrapper {
  .page-title{
    float:left;
    width: 90%;
    height: 24px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 25px;
  }
  .box-card{
    width: 100%;
  }
}
</style>
